#include "header.h"


int main(int argc, char **argv)
{
	pthread_attr_t  newattr;

	int    i, j, k;
	size_t Size;
        unsigned long *ulptr;

	
	parse_args(argc, argv);


        printf("%s: Shared Memory Test Program\n\n", *argv);

        printf("\tNumber of  writers thread   = %d\n", num_writers);
        printf("\tNumber of  readers thread   = %d\n", num_readers);
        printf("\tShared Memory Size in Bytes = %d\n", buffer_size);
        printf("\n");


	for(i = 0; i < num_writers; i++)
	{
		j = i * 3;
		/*Size = sizeof(int);*/
		Size = buffer_size; 

		if((shmid[j] = shmget(IPC_PRIVATE, Size, SHMEM_MODE)) < 0)
			perror("Shmget Error");

		if((shmaddr[i] = (char *)shmat(shmid[j], 0, 0)) == (void *)-1){
			perror("Shmat Error");
			exit(1);
		}		

/********* Reader Check Sum  ****************

	        j++;
        	Size = sizeof(unsigned long) * num_readers;


 	       if((shmid[j] = shmget(IPC_PRIVATE, Size, SHMEM_MODE)) < 0)
        	        perror("Checksum Shmget Failed");


 	       if((long)(checksum[i] = (unsigned long *) \
                                         shmat(shmid[j], 0, 0)) == -1)
        	        perror("Shmat Failed : Shared Memory Attach Error ");


 	       ulptr = checksum[i];
	
		ulptr = (unsigned long *) malloc(sizeof(unsigned long *));

        	for(k = 0; k < num_readers; k++)
        	{
                	*ulptr = 0;
                	ulptr++;
        	}

********* End Reader Check Sum  ****************/


	}
	

	writer_th = (pthread_t *) malloc((size_t) (num_writers \
                                            * sizeof(pthread_t)));
 	reader_th = (pthread_t *) malloc((size_t) (num_writers \
                              * num_readers * sizeof(pthread_t)));


 	for(i = 0; i < num_writers; i++) {

 	if(pthread_mutex_init(&mutex_r[i] , (pthread_mutexattr_t *)NULL) != 0)
        	 perror("Can't Initialise Mutex");


 	if(pthread_mutex_init (&cond_mutex[i], (pthread_mutexattr_t *)NULL)!=0)
        	 perror("Can't Initialize Cond_Mutex");


 	if(pthread_cond_init (&cond_var[i], (pthread_condattr_t *)NULL)!=0)
        	 perror("Cond_Var Failed");


 	thread_hold[i] = 1;
 	}

 	if(pthread_attr_init(&newattr))
  	      perror("Attr_Init Failed");


 	if(pthread_attr_setdetachstate(&newattr, PTHREAD_CREATE_JOINABLE)){
        	 perror("Attr_Setdetachstate Failed");
         	 printf("Successful\n");
 	}


/***************************************************************************
        for(i = 0; i < num_writers; i++)
        {
                if(pthread_create(&writer_th[i], &newattr, writer, \
                                                        (void *) (long)i))
                        perror("Writer Failed");
	}

        for(i = 0; i < num_writers; i++)
        {
        	if(pthread_create(&reader_th[i], &newattr, reader,\
                                                        (void *) (long)j))

                        perror("Reader Failed");
        }


        for(i = 0; i < num_writers; i++)
        {
               if(pthread_join(writer_th[i], NULL)) {
                        printf("writer_th: pthread_join return: %d\n",i);

                        perror("Pthread_join Bad Status");
                }
	}
        for(i = 0; i < num_writers; i++)
        {
        	if(pthread_join(reader_th[i], NULL)) {
                perror("Pthread_join Bad Status");
                }
        }

}




**********************************************************************/
        for(i = 0; i < num_writers; i++)
        {


                if(pthread_create(&writer_th[i], &newattr, writer, \
                                                        (void *) (long)i))
                        perror("Writer Failed");

                k = i * num_readers;


                for(j = k; j < (k + num_readers) ; j++)
                {
                        if(pthread_create(&reader_th[j], &newattr, reader,\
                                                        (void *) (long)j))

                        perror("Reader Failed");
                }
        }


        for(i = 0; i < num_writers; i++)
        {
               if(pthread_join(writer_th[i], NULL)) {
                        printf("writer_th: pthread_join return: %d\n",i);

                        perror("Pthread_join Bad Status");
                }

                k = i * num_readers;


                for(j = k; j < (k + num_readers) ; j++)
                {
                        if(pthread_join(reader_th[j], NULL)) {
                        perror("Pthread_join Bad Status");
                        }
                }
        }


/*********** CheckSum Calculation ************
	
        for(i = 0; i < num_writers; i++)
        {
                ulptr = checksum[i];
                for(j = 0; j < num_readers; j++) {

                        if(cksum[i] != *ulptr )
                                error("checksums do not match", __LINE__);

                }
        }
*********** End CheckSum Calculation ************/

        printf("\n\tMain: Thread Created Successfully\n");

        release();
        printf("\nsuccessful!\n");

        return(0);

}

